"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.catchCount = exports.failKey = exports.successKey = void 0;
const log_1 = require("../log");
exports.successKey = Symbol('success');
exports.failKey = Symbol('fail');
const catchCount = () => {
    return function (target, propertyKey, descriptor) {
        const origin = descriptor === null || descriptor === void 0 ? void 0 : descriptor.value;
        target[exports.successKey] = 0;
        target[exports.failKey] = 0;
        descriptor.value = function (...args) {
            return __awaiter(this, void 0, void 0, function* () {
                try {
                    const res = yield (origin === null || origin === void 0 ? void 0 : origin.apply(this, args));
                    target[exports.successKey]++;
                    log_1.success(`success: ${target[exports.successKey]};fail: ${target[exports.failKey]}`);
                    return res;
                }
                catch (e) {
                    log_1.error(`${propertyKey} ${args.join(',')} ${e}`);
                    target[exports.failKey]++;
                }
            });
        };
    };
};
exports.catchCount = catchCount;
//# sourceMappingURL=catchCount.js.map