"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Segmentfault = void 0;
const base_1 = require("../base");
const axios_1 = __importDefault(require("axios"));
const sitdown_1 = require("sitdown");
const cheerio_1 = __importDefault(require("cheerio"));
const decorator_1 = require("../../decorator");
const platform_1 = require("../../decorator/platform");
const sitdown = new sitdown_1.Sitdown({
    keepFilter: ['style'],
    codeBlockStyle: 'fenced',
    bulletListMarker: '-',
    hr: '---',
});
let Segmentfault = class Segmentfault extends base_1.Base {
    constructor() {
        super(...arguments);
        this.headers = {};
    }
    getDetail(url) {
        return __awaiter(this, void 0, void 0, function* () {
            const { data: html } = yield axios_1.default.get(`https://segmentfault.com${url}`);
            const $ = cheerio_1.default.load(html);
            const content = sitdown.HTMLToMD($('.article').html());
            const date = $('time').attr('datetime');
            const tags = [];
            const title = $('#sf-article_title .text-body').text();
            $('.m-n1 .badge-tag').each(function () {
                tags.push($(this).text().replace(/\s/g, ''));
            });
            return {
                date,
                categories: [],
                content,
                title,
                tags,
            };
        });
    }
    getMain() {
        return __awaiter(this, void 0, void 0, function* () {
            let page = 1;
            const urls = [];
            let emptyBreak = false;
            while (true) {
                const { data: html } = yield axios_1.default.get(`https://segmentfault.com/u/${this.config.userId}/articles?page=${page++}`);
                if (emptyBreak) {
                    break;
                }
                const $ = cheerio_1.default.load(html);
                const list = $('.profile-mine__content--title');
                if ((list === null || list === void 0 ? void 0 : list.length) > 0) {
                    list.each(function () {
                        const url = $(this).attr('href');
                        if (url) {
                            urls.push(url);
                        }
                    });
                }
                else {
                    break;
                }
            }
            return urls;
        });
    }
};
__decorate([
    decorator_1.catchCount()
], Segmentfault.prototype, "getDetail", null);
Segmentfault = __decorate([
    platform_1.platform('segmentfault')
], Segmentfault);
exports.Segmentfault = Segmentfault;
//# sourceMappingURL=index.js.map